%% tau histograms
clear;
load('data/template_data_power_templates.mat')
task_names_run = {'rest',   'WM',    'lang',  'motor', 'social', 'gambling', 'relational', 'emotion'};


for t=1:8
    tau_info(t).c_gt_1s=[];
    tau_info(t).c_gt_2s=[];
   for c=1:42
              gam = template_data(t).estParams.gamma(c); time_scale = 720/sqrt(gam);  tau = int32(time_scale);
              tau_list(t,c)=tau;     
              if tau>1000
              tau_info(t).c_gt_1s=[tau_info(t).c_gt_1s c];
              end
              if tau>2000
              tau_info(t).c_gt_2s=[tau_info(t).c_gt_2s c];
              end
   end    
end

%% hist of all
all_taus=reshape(tau_list,1,8*42);
x=log10(double(all_taus)); 
h=histogram(x,'BinWidth',0.1,'Facealpha',0.5,'EdgeColor','none');

    xl_int=[500 1000 5000 10000];

   for i=1:length(xl_int)
       xt(i)=log10(xl_int(i));
      xl{i}=num2str(xl_int(i)); 
   end
    set(gca,'XTick',xt,'XTickLabel',xl);
xlabel('(tau) (ms)'); % xlabel('log10(tau) (ms)');
ylabel('no. of components'); 
hold on;plot([3 3],[0 70],'--k'); % mark 1000 ms
set(gca,'TickLength', [0.01, 0.01])
title('taus of all tasks');

%% hist of each task -SI Fig S2
for tt=1:8
    subplot(2,4,tt);
x=log10(double(tau_list(tt,:))); 
h=histogram(x,'BinWidth',0.1,'Facealpha',0.5,'EdgeColor','none');

    xl_int=[500 1000 5000 10000];

   for i=1:length(xl_int)
       xt(i)=log10(xl_int(i));
      xl{i}=num2str(xl_int(i)); 
   end
    set(gca,'XTick',xt,'XTickLabel',xl);
xlabel('(tau) (ms)'); % xlabel('log10(tau) (ms)');
ylabel('no. of components'); 
hold on;plot([3 3],[0 10],'--k'); % mark 1000 ms
set(gca,'TickLength', [0.01, 0.01]);
title(task_names_run{tt});
end




