%% iterative classification

addpath(genpath('../../../addons/gpfa_v0203'));
addpath(genpath('../../../addons/chronux_2_12'));

clc; clear; 
task_names_run  = {'rest',   'WM',    'lang',  'motor', 'social', 'gambling', 'relational', 'emotion'};
task_names_cells = {'resting','task7', 'task2', 'task4', 'task6',  'task3',    'task5',      'task1'}; %matrix names

rmpath(genpath('spm12/'));
rmpath(genpath('spm8/'));

Fs=1000/720;
%% find order of 'goodness' of components - for gpfa, gpfaOrth, PCA

clc;
% the following were created in X2_1_*.m
% load('../Sha_corr_oscilComp_and_latentSeries_gpfa.mat');
% load('../Sha_corr_oscilComp_and_latentSeries_gpfaOrth.mat');
load('../Sha_corr_oscilComp_and_latentSeries_PCA.mat');

% components to consider, for each task
for t=1:8
    cc(t).use_c=[1:42];
end

%for each task, sort components based on goodness/usefulness to predict 
for pt = 2:8
    clear sub_wise_scores_lt sub_wise_scores_os;
   for sub=1:900
        bla_lt=zeros(size(cc(pt).use_c));
        bla_os=zeros(size(cc(pt).use_c));
        
    for at=setdiff(2:8,pt) % other tasks - corrs to be avgd. and subtracted
        bla_lt=bla_lt+corr_latentSeries(sub,at,pt).corrs(cc(pt).use_c);
        
        bla_os=bla_os+corr_oscilComp(sub,at,pt).corrs(cc(pt).use_c);
    end
       bla_lt=bla_lt./length(setdiff(2:8,pt));
       bla_os=bla_os./length(setdiff(2:8,pt));
       
       t = pt; % looking for weakest component in task pt
% [~,idx]= min(corr_latentSeries(sub,t,t).corrs(cc(t).use_c) - bla);
% weakest component found for t : cc(t).use_c(idx)
       sub_wise_scores_lt(sub,:)=corr_latentSeries(sub,t,t).corrs(cc(t).use_c) - bla_lt;
       sub_wise_scores_os(sub,:)=corr_oscilComp(sub,t,t).corrs(cc(t).use_c) - bla_os;
   end
       [~,eliminate_order_lt(pt,:)]=sort(mean(sub_wise_scores_lt));
       [~,eliminate_order_os(pt,:)]=sort(mean(sub_wise_scores_os));

end

% save('elim_order_gpfa.mat','eliminate_order_lt','eliminate_order_os')
% save('elim_order_gpfaOrth.mat','eliminate_order_lt','eliminate_order_os')
save('elim_order_PCA.mat','eliminate_order_lt','eliminate_order_os')



%% getting confusion mat diagonal at an iteration of eliminating components

%******
do_for='PCA'; %'gpfa' ,'gpfaOrth' ,'PCA'
%*******

load(strcat('elim_order_',do_for,'.mat'));
load(strcat('../Sha_corr_oscilComp_and_latentSeries_',do_for,'.mat'));

confusion_mat_lt=zeros(42,8,8);confusion_mat_os=zeros(42,8,8);
for iter=1:42
    % iter|#compUsed : 1|42  , 2|41 ,  ... ,42|1
for at = 2:8
    for sub=1:900
        clear match_corr;
        for pt=2:8
            corr_val=corr_latentSeries(sub,at,pt).corrs(eliminate_order_lt(pt,iter:42));
            match_corr_lt(pt) = sum(corr_val)/length(corr_val);
            
            corr_val=corr_oscilComp(sub,at,pt).corrs(eliminate_order_os(pt,iter:42));
            match_corr_os(pt) = sum(corr_val)/length(corr_val);
        end
           [~,idx]=max(match_corr_lt(2:8)); idx=idx+1;
           confusion_mat_lt(iter,at, idx) =  confusion_mat_lt(iter,at, idx) + 1;
           
           [~,idx]=max(match_corr_os(2:8)); idx=idx+1;
           confusion_mat_os(iter,at, idx) =  confusion_mat_os(iter,at, idx) + 1;
    end
end

end

for t=2:8
    Acc_lt(t,:)= confusion_mat_lt(:,t,t)./9;
    Acc_os(t,:)= confusion_mat_os(:,t,t)./9;    
end
save(strcat('data/Accuracies_all_iter_',do_for,'.mat'),'confusion_mat_lt','confusion_mat_os','Acc_lt','Acc_os');
