

load('Fig1/data/template_data_power_templates.mat')
load('Sha_corr_oscilComp_and_latentSeries_gpfa.mat');% created in X2_2_*.m

task_names_run = {'rest', 'WM',  'lang',  'motor', 'social', 'gambling', 'relational', 'emotion'};


for t=1:8
    for c=1:42
        gam = template_data(t).estParams.gamma(c); time_scale = 720/sqrt(gam);  tau = int32(time_scale);
        tau_list(t,c)=tau;
    end
end


for sub_task=1:8 %actual task
    disp(task_names_run{sub_task});
    for sub=1:900
        if mod(sub,50)==1
            fprintf('%d ', sub);
        end
        corr_vals(sub_task,sub,:)=corr_latentSeries(sub,sub_task,sub_task).corrs(:);
    end
end

avg_of_900sub=squeeze(mean(corr_vals,2));
colors = [0,0,1;1,0,0;0,1,0;0,0,0.172413793103448;1,0.103448275862069,0.724137931034483;1,0.827586206896552,0;0,0.344827586206897,0;0.517241379310345,0.517241379310345,1];

%% Fig 2c

figure;
t=2 ;% for WM task
plot(log10(double(tau_list(t,:)))  , avg_of_900sub(t,:),'o','MarkerSize',8,'MarkerEdgeColor',colors(t,:))%,'MarkerFaceColor',colors(t,:)); %hold on;

[rho,p]=corr(log10(double(tau_list(t,:)))',avg_of_900sub(t,:)');
title(sprintf('%s  rho:%.2f p=%f',task_names_run{t},rho,p));
xlabel('(tau) ms');ylabel('42 corrs');
ylim([-0.1 0.8]);
xlim([2.5 4.5]);

xl_int=[500 1000 5000 10000];

for i=1:length(xl_int)
    xt(i)=log10(xl_int(i));
    xl{i}=num2str(xl_int(i));
end
set(gca,'XTick',xt,'XTickLabel',xl);

suptitle('WM : 42 traj template-test corr vs log10(tau)');


%% Supp Info Fig S2 - all tasks

figure;
for t=1:8
    subplot(2,4,t);
    plot(log10(double(tau_list(t,:)))  , avg_of_900sub(t,:),'.','MarkerSize',20,'MarkerEdgeColor',colors(t,:))%,'MarkerFaceColor',colors(t,:)); %hold on;
    
    [rho,p]=corr(log10(double(tau_list(t,:)))',avg_of_900sub(t,:)');
    title(sprintf('%s  rho:%.2f p=%f',task_names_run{t},rho,p));
    xlabel('(tau) ms');ylabel('42 corrs');
    ylim([-0.1 0.8]);
    xlim([2.5 4.5]);
    xl_int=[500 1000 5000 10000];
    
    for i=1:length(xl_int)
        xt(i)=log10(xl_int(i));
        xl{i}=num2str(xl_int(i));
    end
    set(gca,'XTick',xt,'XTickLabel',xl);
end
suptitle('42 traj: template-test corr vs log10(tau)');


