addpath(genpath('gpfa_v0203'));
addpath(genpath('chronux_2_12'));

clear;clc;
display_name_cells={'rest','WM','lang','motor','social','gambling','relational','emotion'}; %human name for the task variables
task_names_cells = {'resting','task7', 'task2', 'task4','task6','task3','task5','task1'}; %matrix names

%% Lang 3 math story
for minimize =1
task_idx = 3;
task_name = display_name_cells{task_idx};
total_points_to_consider = 100;

load('Fig1/data/template_subjects_IDs.mat');
task_mat_name = sprintf('tc_%s_concat', task_names_cells{strcmp(display_name_cells, task_name)});
load('/core_scripts/data/gpfa_%s_power_xDim_42.mat', task_name), 'estParams'); 
load('/core_scripts/data/tc_all_lr_power_808_subs.mat', task_mat_name);

data_all = eval(task_mat_name);

clear task_mat_name;

folder = 'EV_files_final_1000'; % downloaded from HCP database

[total_points, no_regions, no_subs] = size(data_all);

sub_count = 1;
seqTrain = [];

sub_task_1=[];
sub_task_2=[];
ROI_series=[];

for sub=1:100   
   
    task_structure = zeros(1, total_points);
    sub_id = num2str(template_subjects_IDs(sub));
 %math    
    curr_points = load(sprintf('%s/%s/LR/%s.txt', folder, sub_id, 'math'));
    for c=1:size(curr_points, 1)
        start_point = round(curr_points(c, 1)*1000/720) + 1;
        end_point = round((curr_points(c, 1) + curr_points(c, 2))*1000/720) + 1;
        task_structure(start_point:end_point) = 1;
    end   
    task_structure = task_structure(11:110);    
    sub_task_1=[sub_task_1 task_structure];
    
%story    
        task_structure = zeros(1, total_points);
        curr_points = load(sprintf('%s/%s/LR/%s.txt', folder, sub_id, 'story'));
    for c=1:size(curr_points, 1)
        start_point = round(curr_points(c, 1)*1000/720) + 1;
        end_point = round((curr_points(c, 1) + curr_points(c, 2))*1000/720) + 1;
        task_structure(start_point:end_point) = 1;
    end
    task_structure = task_structure(11:110);    
    sub_task_2=[sub_task_2 task_structure];
    ROI_series = [ROI_series squeeze(data_all(11:110,:,sub))'];
    
end  

mean_ROI=mean(ROI_series'); std_ROI=std(ROI_series');

mean_mat=repmat(mean_ROI',[1,size(ROI_series,2)]);
std_mat = repmat(std_ROI',[1,size(ROI_series,2)]);

norm_ROIs=(ROI_series - mean_mat)./std_mat;

% mvregress
X=[sub_task_1' sub_task_2'];
Y=norm_ROIs';
clear beta;
for i=1:size(Y,2)
    beta(:,i) = mvregress(X,Y(:,i));   
end
save(strcat('/core_scripts/data/mvreg_',task_name,'.mat'),'X','Y','beta');
% figure; histogram(beta(1,:));
% figure; histogram(beta(2,:));
end
%% WM 2 0bk 2bk
for minimize =1
addpath(genpath('../../../addons/gpfa_v0203'));
addpath(genpath('../../../addons/chronux_2_12'));

clear;clc;
display_name_cells={'rest',   'WM',    'lang',  'motor', 'social', 'gambling', 'relational', 'emotion'}; %human name for the task variables
task_names_cells = {'resting','task7', 'task2', 'task4', 'task6',  'task3',    'task5', 'task1'}; %matrix names

task_idx = 2;
task_name = display_name_cells{task_idx};
total_points_to_consider = 100;

load('Fig1/data/template_subjects_IDs.mat');
task_mat_name = sprintf('tc_%s_concat', task_names_cells{strcmp(display_name_cells, task_name)});
load('/core_scripts/data/gpfa_%s_power_xDim_42.mat', task_name), 'estParams'); 
load('/core_scripts/data/tc_all_lr_power_808_subs.mat', task_mat_name);

data_all = eval(task_mat_name);

clear task_mat_name;

folder = 'EV_files_final_1000'; % downloaded from HCP database

[total_points, no_regions, no_subs] = size(data_all);

sub_count = 1;
seqTrain = [];

sub_task_1=[];
sub_task_2=[];
ROI_series=[];

for sub=1:100   
   
    task_structure = zeros(1, total_points);
    sub_id = num2str(template_subjects_IDs(sub));
 %0bk        
    curr_points = load(sprintf('%s/%s/LR/%s.txt', folder, sub_id, '0bk_body'));
    for c=1:size(curr_points, 1)
        start_point = round(curr_points(c, 1)*1000/720) + 1;
        end_point = round((curr_points(c, 1) + curr_points(c, 2))*1000/720) + 1;
        task_structure(start_point:end_point) = 1;
    end
    
    curr_points = load(sprintf('%s/%s/LR/%s.txt', folder, sub_id, '0bk_faces'));
    for c=1:size(curr_points, 1)
        start_point = round(curr_points(c, 1)*1000/720) + 1;
        end_point = round((curr_points(c, 1) + curr_points(c, 2))*1000/720) + 1;
        task_structure(start_point:end_point) = 1;
    end
    
    curr_points = load(sprintf('%s/%s/LR/%s.txt', folder, sub_id, '0bk_places'));
    for c=1:size(curr_points, 1)
        start_point = round(curr_points(c, 1)*1000/720) + 1;
        end_point = round((curr_points(c, 1) + curr_points(c, 2))*1000/720) + 1;
        task_structure(start_point:end_point) = 1;
    end
    
    curr_points = load(sprintf('%s/%s/LR/%s.txt', folder, sub_id, '0bk_tools'));
    for c=1:size(curr_points, 1)
        start_point = round(curr_points(c, 1)*1000/720) + 1;
        end_point = round((curr_points(c, 1) + curr_points(c, 2))*1000/720) + 1;
        task_structure(start_point:end_point) = 1;
    end
    
    task_structure = task_structure(11:110);    
    sub_task_1=[sub_task_1 task_structure];
    
%2bk    
        task_structure = zeros(1, total_points);
    curr_points = load(sprintf('%s/%s/LR/%s.txt', folder, sub_id, '2bk_body'));
    for c=1:size(curr_points, 1)
        start_point = round(curr_points(c, 1)*1000/720) + 1;
        end_point = round((curr_points(c, 1) + curr_points(c, 2))*1000/720) + 1;
        task_structure(start_point:end_point) = 1;
    end
    
    curr_points = load(sprintf('%s/%s/LR/%s.txt', folder, sub_id, '2bk_faces'));
    for c=1:size(curr_points, 1)
        start_point = round(curr_points(c, 1)*1000/720) + 1;
        end_point = round((curr_points(c, 1) + curr_points(c, 2))*1000/720) + 1;
        task_structure(start_point:end_point) = 1;
    end
    
    curr_points = load(sprintf('%s/%s/LR/%s.txt', folder, sub_id, '2bk_places'));
    for c=1:size(curr_points, 1)
        start_point = round(curr_points(c, 1)*1000/720) + 1;
        end_point = round((curr_points(c, 1) + curr_points(c, 2))*1000/720) + 1;
        task_structure(start_point:end_point) = 1;
    end
    
    curr_points = load(sprintf('%s/%s/LR/%s.txt', folder, sub_id, '2bk_tools'));
    for c=1:size(curr_points, 1)
        start_point = round(curr_points(c, 1)*1000/720) + 1;
        end_point = round((curr_points(c, 1) + curr_points(c, 2))*1000/720) + 1;
        task_structure(start_point:end_point) = 1;
    end
    task_structure = task_structure(11:110);    
    sub_task_2=[sub_task_2 task_structure];
    ROI_series = [ROI_series squeeze(data_all(11:110,:,sub))'];
    
end  

mean_ROI=mean(ROI_series'); std_ROI=std(ROI_series');

mean_mat=repmat(mean_ROI',[1,size(ROI_series,2)]);
std_mat = repmat(std_ROI',[1,size(ROI_series,2)]);

norm_ROIs=(ROI_series - mean_mat)./std_mat;

% mvregress
X=[sub_task_1' sub_task_2'];
Y=norm_ROIs';
clear beta;
for i=1:size(Y,2)
    beta(:,i) = mvregress(X,Y(:,i));   
end
save(strcat('/core_scripts/data/mvreg_',task_name,'.mat'),'X','Y','beta');
end
%%  motor 4 hand,foot
for minimize =1
    addpath(genpath('../../../addons/gpfa_v0203'));
addpath(genpath('../../../addons/chronux_2_12'));

clear;clc;
display_name_cells={'rest',   'WM',    'lang',  'motor', 'social', 'gambling', 'relational', 'emotion'}; %human name for the task variables
task_names_cells = {'resting','task7', 'task2', 'task4', 'task6',  'task3',    'task5', 'task1'}; %matrix names

task_idx = 4;
task_name = display_name_cells{task_idx};
total_points_to_consider = 100;

load('Fig1/data/template_subjects_IDs.mat');
task_mat_name = sprintf('tc_%s_concat', task_names_cells{strcmp(display_name_cells, task_name)});
load('/core_scripts/data/gpfa_%s_power_xDim_42.mat', task_name), 'estParams'); 
load('/core_scripts/data/tc_all_lr_power_808_subs.mat', task_mat_name);

data_all = eval(task_mat_name);

clear task_mat_name;

folder = 'EV_files_final_1000'; % downloaded from HCP database

[total_points, no_regions, no_subs] = size(data_all);

sub_count = 1;
seqTrain = [];

sub_task_1=[];
sub_task_2=[];
ROI_series=[];

for sub=1:100   
   
    task_structure = zeros(1, total_points);
    sub_id = num2str(template_subjects_IDs(sub));
 %hand    

     curr_points = load(sprintf('%s/%s/LR/%s.txt', folder, sub_id, 'lh'));
    for c=1:size(curr_points, 1)
        start_point = round(curr_points(c, 1)*1000/720) + 1;
        end_point = round((curr_points(c, 1) + curr_points(c, 2))*1000/720) + 1;
        task_structure(start_point:end_point) = 1;
    end
    
    curr_points = load(sprintf('%s/%s/LR/%s.txt', folder, sub_id, 'rh'));
    for c=1:size(curr_points, 1)
        start_point = round(curr_points(c, 1)*1000/720) + 1;
        end_point = round((curr_points(c, 1) + curr_points(c, 2))*1000/720) + 1;
        task_structure(start_point:end_point) = 1;
    end
   
 task_structure = task_structure(11:110);    
    sub_task_1=[sub_task_1 task_structure];
    
%foot    
        task_structure = zeros(1, total_points);
    curr_points = load(sprintf('%s/%s/LR/%s.txt', folder, sub_id, 'lf'));
    for c=1:size(curr_points, 1)
        start_point = round(curr_points(c, 1)*1000/720) + 1;
        end_point = round((curr_points(c, 1) + curr_points(c, 2))*1000/720) + 1;
        task_structure(start_point:end_point) = 1;
    end
    
    curr_points = load(sprintf('%s/%s/LR/%s.txt', folder, sub_id, 'rf'));
    for c=1:size(curr_points, 1)
        start_point = round(curr_points(c, 1)*1000/720) + 1;
        end_point = round((curr_points(c, 1) + curr_points(c, 2))*1000/720) + 1;
        task_structure(start_point:end_point) = 1;
    end
        task_structure = task_structure(11:110);    
    sub_task_2=[sub_task_2 task_structure];
    ROI_series = [ROI_series squeeze(data_all(11:110,:,sub))'];
    
end  

mean_ROI=mean(ROI_series'); std_ROI=std(ROI_series');

mean_mat=repmat(mean_ROI',[1,size(ROI_series,2)]);
std_mat = repmat(std_ROI',[1,size(ROI_series,2)]);

norm_ROIs=(ROI_series - mean_mat)./std_mat;

% mvregress
X=[sub_task_1' sub_task_2'];
Y=norm_ROIs';
clear beta;
for i=1:size(Y,2)
    beta(:,i) = mvregress(X,Y(:,i));   
end
save(strcat('/core_scripts/data/mvreg_',task_name,'.mat'),'X','Y','beta');
% figure; histogram(beta(1,:));
% figure; histogram(beta(2,:));
end
%% social 5 mental rnd
for minimize =1
    addpath(genpath('../../../addons/gpfa_v0203'));
addpath(genpath('../../../addons/chronux_2_12'));

clear;clc;
display_name_cells={'rest',   'WM',    'lang',  'motor', 'social', 'gambling', 'relational', 'emotion'}; %human name for the task variables
task_names_cells = {'resting','task7', 'task2', 'task4', 'task6',  'task3',    'task5', 'task1'}; %matrix names

task_idx = 5;
task_name = display_name_cells{task_idx};
total_points_to_consider = 100;

load('Fig1/data/template_subjects_IDs.mat');
task_mat_name = sprintf('tc_%s_concat', task_names_cells{strcmp(display_name_cells, task_name)});
load('/core_scripts/data/gpfa_%s_power_xDim_42.mat', task_name), 'estParams'); 
load('/core_scripts/data/tc_all_lr_power_808_subs.mat', task_mat_name);

data_all = eval(task_mat_name);

clear task_mat_name;

folder = 'EV_files_final_1000'; % downloaded from HCP database

[total_points, no_regions, no_subs] = size(data_all);

sub_count = 1;
seqTrain = [];

sub_task_1=[];
sub_task_2=[];
ROI_series=[];

for sub=1:100   
   
    task_structure = zeros(1, total_points);
    sub_id = num2str(template_subjects_IDs(sub));
 %mental    

    curr_points = load(sprintf('%s/%s/LR/%s.txt', folder, sub_id, 'mental'));
    for c=1:size(curr_points, 1)
        start_point = round(curr_points(c, 1)*1000/720) + 1;
        end_point = round((curr_points(c, 1) + curr_points(c, 2))*1000/720) + 1;
        task_structure(start_point:end_point) = 1;
    end
   
 task_structure = task_structure(11:110);    
    sub_task_1=[sub_task_1 task_structure];
    
%random    
        task_structure = zeros(1, total_points);
    curr_points = load(sprintf('%s/%s/LR/%s.txt', folder, sub_id, 'rnd'));
    for c=1:size(curr_points, 1)
        start_point = round(curr_points(c, 1)*1000/720) + 1;
        end_point = round((curr_points(c, 1) + curr_points(c, 2))*1000/720) + 1;
        task_structure(start_point:end_point) = 1;
    end
    
        task_structure = task_structure(11:110);    
    sub_task_2=[sub_task_2 task_structure];
    ROI_series = [ROI_series squeeze(data_all(11:110,:,sub))'];
    
end  

mean_ROI=mean(ROI_series'); std_ROI=std(ROI_series');

mean_mat=repmat(mean_ROI',[1,size(ROI_series,2)]);
std_mat = repmat(std_ROI',[1,size(ROI_series,2)]);

norm_ROIs=(ROI_series - mean_mat)./std_mat;

% mvregress
X=[sub_task_1' sub_task_2'];
Y=norm_ROIs';
clear beta;
for i=1:size(Y,2)
    beta(:,i) = mvregress(X,Y(:,i));   
end
save(strcat('/core_scripts/data/mvreg_',task_name,'.mat'),'X','Y','beta');
% figure; histogram(beta(1,:));
% figure; histogram(beta(2,:));
end
%% gambling 6 win loss
for minimize =1
    addpath(genpath('../../../addons/gpfa_v0203'));
addpath(genpath('../../../addons/chronux_2_12'));

clear;clc;
display_name_cells={'rest',   'WM',    'lang',  'motor', 'social', 'gambling', 'relational', 'emotion'}; %human name for the task variables
task_names_cells = {'resting','task7', 'task2', 'task4', 'task6',  'task3',    'task5', 'task1'}; %matrix names

task_idx = 6;
task_name = display_name_cells{task_idx};
total_points_to_consider = 100;

load('Fig1/data/template_subjects_IDs.mat');
task_mat_name = sprintf('tc_%s_concat', task_names_cells{strcmp(display_name_cells, task_name)});
load('/core_scripts/data/gpfa_%s_power_xDim_42.mat', task_name), 'estParams'); 
load('/core_scripts/data/tc_all_lr_power_808_subs.mat', task_mat_name);

data_all = eval(task_mat_name);

clear task_mat_name;

folder = 'EV_files_final_1000'; % downloaded from HCP database

[total_points, no_regions, no_subs] = size(data_all);

sub_count = 1;
seqTrain = [];

sub_task_1=[];
sub_task_2=[];
ROI_series=[];

for sub=1:100   
   
    task_structure = zeros(1, total_points);
    sub_id = num2str(template_subjects_IDs(sub));
 %win    

    curr_points = load(sprintf('%s/%s/LR/%s.txt', folder, sub_id, 'win'));
    for c=1:size(curr_points, 1)
        start_point = round(curr_points(c, 1)*1000/720) + 1;
        end_point = round((curr_points(c, 1) + curr_points(c, 2))*1000/720) + 1;
        task_structure(start_point:end_point) = 1;
    end
   
 task_structure = task_structure(11:110);    
    sub_task_1=[sub_task_1 task_structure];
    
%loss    
        task_structure = zeros(1, total_points);
    curr_points = load(sprintf('%s/%s/LR/%s.txt', folder, sub_id, 'loss'));
    for c=1:size(curr_points, 1)
        start_point = round(curr_points(c, 1)*1000/720) + 1;
        end_point = round((curr_points(c, 1) + curr_points(c, 2))*1000/720) + 1;
        task_structure(start_point:end_point) = 1;
    end
    
        task_structure = task_structure(11:110);    
    sub_task_2=[sub_task_2 task_structure];
    ROI_series = [ROI_series squeeze(data_all(11:110,:,sub))'];
    
end  

mean_ROI=mean(ROI_series'); std_ROI=std(ROI_series');

mean_mat=repmat(mean_ROI',[1,size(ROI_series,2)]);
std_mat = repmat(std_ROI',[1,size(ROI_series,2)]);

norm_ROIs=(ROI_series - mean_mat)./std_mat;

% mvregress
X=[sub_task_1' sub_task_2'];
Y=norm_ROIs';
clear beta;
for i=1:size(Y,2)
    beta(:,i) = mvregress(X,Y(:,i));   
end
save(strcat('/core_scripts/data/mvreg_',task_name,'.mat'),'X','Y','beta');
% figure; histogram(beta(1,:));
% figure; histogram(beta(2,:));
end
%% relational 7 relation match
for minimize =1
    addpath(genpath('../../../addons/gpfa_v0203'));
addpath(genpath('../../../addons/chronux_2_12'));

clear;clc;
display_name_cells={'rest',   'WM',    'lang',  'motor', 'social', 'gambling', 'relational', 'emotion'}; %human name for the task variables
task_names_cells = {'resting','task7', 'task2', 'task4', 'task6',  'task3',    'task5', 'task1'}; %matrix names

task_idx = 7;
task_name = display_name_cells{task_idx};
total_points_to_consider = 100;

load('Fig1/data/template_subjects_IDs.mat');
task_mat_name = sprintf('tc_%s_concat', task_names_cells{strcmp(display_name_cells, task_name)});
load('/core_scripts/data/gpfa_%s_power_xDim_42.mat', task_name), 'estParams'); 
load('/core_scripts/data/tc_all_lr_power_808_subs.mat', task_mat_name);

data_all = eval(task_mat_name);

clear task_mat_name;

folder = 'EV_files_final_1000'; % downloaded from HCP database

[total_points, no_regions, no_subs] = size(data_all);

sub_count = 1;
seqTrain = [];

sub_task_1=[];
sub_task_2=[];
ROI_series=[];

for sub=1:100   
   
    task_structure = zeros(1, total_points);
    sub_id = num2str(template_subjects_IDs(sub));
 %relation    

    curr_points = load(sprintf('%s/%s/LR/%s.txt', folder, sub_id, 'relation'));
    for c=1:size(curr_points, 1)
        start_point = round(curr_points(c, 1)*1000/720) + 1;
        end_point = round((curr_points(c, 1) + curr_points(c, 2))*1000/720) + 1;
        task_structure(start_point:end_point) = 1;
    end
   
 task_structure = task_structure(11:110);    
    sub_task_1=[sub_task_1 task_structure];
    
%match    
        task_structure = zeros(1, total_points);
    curr_points = load(sprintf('%s/%s/LR/%s.txt', folder, sub_id, 'match'));
    for c=1:size(curr_points, 1)
        start_point = round(curr_points(c, 1)*1000/720) + 1;
        end_point = round((curr_points(c, 1) + curr_points(c, 2))*1000/720) + 1;
        task_structure(start_point:end_point) = 1;
    end
    
        task_structure = task_structure(11:110);    
    sub_task_2=[sub_task_2 task_structure];
    ROI_series = [ROI_series squeeze(data_all(11:110,:,sub))'];
    
end  

mean_ROI=mean(ROI_series'); std_ROI=std(ROI_series');

mean_mat=repmat(mean_ROI',[1,size(ROI_series,2)]);
std_mat = repmat(std_ROI',[1,size(ROI_series,2)]);

norm_ROIs=(ROI_series - mean_mat)./std_mat;

% mvregress
X=[sub_task_1' sub_task_2'];
Y=norm_ROIs';
clear beta;
for i=1:size(Y,2)
    beta(:,i) = mvregress(X,Y(:,i));   
end
save(strcat('/core_scripts/data/mvreg_',task_name,'.mat'),'X','Y','beta');
% figure; histogram(beta(1,:));
% figure; histogram(beta(2,:));
end

%% emotion 8 neut fear
for minimize =1
    addpath(genpath('../../../addons/gpfa_v0203'));
addpath(genpath('../../../addons/chronux_2_12'));

clear;clc;
display_name_cells={'rest',   'WM',    'lang',  'motor', 'social', 'gambling', 'relational', 'emotion'}; %human name for the task variables
task_names_cells = {'resting','task7', 'task2', 'task4', 'task6',  'task3',    'task5', 'task1'}; %matrix names

task_idx = 8;
task_name = display_name_cells{task_idx};
total_points_to_consider = 100;

load('Fig1/data/template_subjects_IDs.mat');
task_mat_name = sprintf('tc_%s_concat', task_names_cells{strcmp(display_name_cells, task_name)});
load('/core_scripts/data/gpfa_%s_power_xDim_42.mat', task_name), 'estParams'); 
load('/core_scripts/data/tc_all_lr_power_808_subs.mat', task_mat_name);

data_all = eval(task_mat_name);

clear task_mat_name;

folder = 'EV_files_final_1000'; % downloaded from HCP database

[total_points, no_regions, no_subs] = size(data_all);

sub_count = 1;
seqTrain = [];

sub_task_1=[];
sub_task_2=[];
ROI_series=[];

for sub=1:100   
   
    task_structure = zeros(1, total_points);
    sub_id = num2str(template_subjects_IDs(sub));
 %win    

    curr_points = load(sprintf('%s/%s/LR/%s.txt', folder, sub_id, 'neut'));
    for c=1:size(curr_points, 1)
        start_point = round(curr_points(c, 1)*1000/720) + 1;
        end_point = round((curr_points(c, 1) + curr_points(c, 2))*1000/720) + 1;
        task_structure(start_point:end_point) = 1;
    end
   
 task_structure = task_structure(11:110);    
    sub_task_1=[sub_task_1 task_structure];
    
%loss    
        task_structure = zeros(1, total_points);
    curr_points = load(sprintf('%s/%s/LR/%s.txt', folder, sub_id, 'fear'));
    for c=1:size(curr_points, 1)
        start_point = round(curr_points(c, 1)*1000/720) + 1;
        end_point = round((curr_points(c, 1) + curr_points(c, 2))*1000/720) + 1;
        task_structure(start_point:end_point) = 1;
    end
    
        task_structure = task_structure(11:110);    
    sub_task_2=[sub_task_2 task_structure];
    ROI_series = [ROI_series squeeze(data_all(11:110,:,sub))'];
    
end  

mean_ROI=mean(ROI_series'); std_ROI=std(ROI_series');

mean_mat=repmat(mean_ROI',[1,size(ROI_series,2)]);
std_mat = repmat(std_ROI',[1,size(ROI_series,2)]);

norm_ROIs=(ROI_series - mean_mat)./std_mat;

% mvregress
X=[sub_task_1' sub_task_2'];
Y=norm_ROIs';
clear beta;
for i=1:size(Y,2)
    beta(:,i) = mvregress(X,Y(:,i));   
end
save(strcat('/core_scripts/data/mvreg_',task_name,'.mat'),'X','Y','beta');
% figure; histogram(beta(1,:));
% figure; histogram(beta(2,:));
end

