%% top 42:8:150 ROIs based on |beta1|,|beta2|
clear;clc;
addpath(genpath('../../../addons/gpfa_v0203'));
addpath(genpath('../../../addons/chronux_2_12'));


display_name_cells={'rest',   'WM',    'lang',  'motor', 'social', 'gambling', 'relational', 'emotion'}; %human name for the task variables
task_names_cells = {'resting','task7', 'task2', 'task4', 'task6',  'task3',    'task5', 'task1'}; %matrix names

for task_idx=2:8
    
    task_name = display_name_cells{task_idx};
    load(strcat('/core_scripts/data/mvreg_',task_name,'.mat'));
    
    betas=[abs(beta(1,:)) abs(beta(2,:))];
    [~,Ub_idx]=sort(betas,'descend');    
    Ub_idx = mod(Ub_idx,size(beta,2));  Ub_idx(Ub_idx==0)=size(beta,2);
    [a,b]=unique(Ub_idx);
    [~,p] = sort(b,'ascend');
    r = 1:length(b);   r(p) = r;
    Ub_idx_264(r)=a;
    
    ROIs_top(task_idx,:)=Ub_idx_264;

    task_mat_name = sprintf('tc_%s_concat', task_names_cells{strcmp(display_name_cells, task_name)});
    load('/core_scripts/data/tc_all_lr_power_808_subs.mat', task_mat_name);
    data_all = eval(task_mat_name);
    mean_template(task_idx,:,:) = mean(data_all(11:110,:,1:100),3);

end
 save('data/Ub_mean_orderedROIs.mat','ROIs_top');

task_names_run = {'rest',   'WM',    'lang',  'motor', 'social', 'gambling', 'relational', 'emotion'};
display_name_cells={'rest',   'WM',    'lang',  'motor', 'social', 'gambling', 'relational', 'emotion'}; %human name for the task variables
task_names_cells = {'rest1','task7', 'task2', 'task4', 'task6',  'task3',    'task5',      'task1'}; %matrix names
all_mat_name = '/core_scripts/data/tc_all_LR_power_predictOn900.mat';
    

%% classify
confusion_mat=zeros(150,8,8);
for i = 2:8 % i is actual task
    
    task_name_actual = task_names_run{i}
    task_mat_name = sprintf('tc_%s_concat', task_names_cells{strcmp(display_name_cells, task_name_actual)});
    
    load(all_mat_name,task_mat_name);
    
    data_all = eval(task_mat_name);
%     [T, no_regions, no_subs] = size(data_all);
    
   
    for sub = 1:900
       if mod(sub,50)==0
           fprintf('%d,',sub);
       end
       
       for take_ROIs = 42:8:150
           clear result;
        for match_with=2:8
            y=squeeze(data_all(11:110,ROIs_top(match_with,1:take_ROIs),sub));
            x=squeeze(mean_template(match_with,:,ROIs_top(match_with,1:take_ROIs)));
        
            [r,~] = corr(x,y);
            result(match_with)=mean(diag(r));
        end
        [~,id]=max(result);
        confusion_mat(take_ROIs,i,id)=confusion_mat(take_ROIs,i,id)+1;
        
    end
    end

end      
  
save('data/Ub_ROI_top_classify.mat','confusion_mat');



%% plot
load('data/Ub_ROI_top_classify.mat');
confusion_mat=squeeze(confusion_mat(42,2:8,2:8));
ROI_accuracies=diag(confusion_mat);

load('data/GPFA42_confusion_mat_without_rest_label');
confusion_mat=confusion_mat(2:8,2:8)
GPFA_accuracies=diag(confusion_mat);

%% pairwise signrank test

[p,h] = signrank(GPFA_accuracies./900, ROI_accuracies./900) % p =  0.0156; h=1;

%% plot as bars
close all;
tasks  = {'W','L','M','S','G','R','E'};

colors = [1,0,0;0,1,0;0,0,0.172413793103448;1,0.103448275862069,0.724137931034483;1,0.827586206896552,0;0,0.344827586206897,0;0.517241379310345,0.517241379310345,1];

for i=1:7
   plot([1 2],[GPFA_accuracies(i)/900  ROI_accuracies(i)/900],'--o','MarkerEdgeColor',colors(i,:),'Color',colors(i,:)) ;hold on;
end

title('compare with accuracies of top 42 ROI');
legend(tasks,'Location','NorthEastOutside');
hold on;
bar([mean(GPFA_accuracies./900)  mean(ROI_accuracies./900)],'FaceColor','None','BarWidth',0.2);
ylim([0.75 1]); set(gca,'XTick',[1 2],'XTickLabel',{'gpfa','ROI'});

%% top 42 ROIs based on |beta1|,|beta2|
% classify based on spectral features
clear;clc;
addpath(genpath('../../../addons/gpfa_v0203'));
addpath(genpath('../../../addons/chronux_2_12'));

task_names_run = {'rest',   'WM',    'lang',  'motor', 'social', 'gambling', 'relational', 'emotion'};
display_name_cells={'rest',   'WM',    'lang',  'motor', 'social', 'gambling', 'relational', 'emotion'}; %human name for the task variables
task_names_cells = {'rest1','task7', 'task2', 'task4', 'task6',  'task3',    'task5',      'task1'}; %matrix names
all_mat_name = '/core_scripts/data/tc_all_LR_power_predictOn900.mat';
rmpath(genpath('spm12/'));
rmpath(genpath('spm8/'));

clc;
Fs=1000/720;
 load('data/Ub_mean_orderedROIs.mat','ROIs_top');
 

for task_idx=2:8
    tic;
    task_name = display_name_cells{task_idx}   
%     ROIs_top(task_idx,:)=;
    task_mat_name = sprintf('tc_%s_concat', task_names_cells{strcmp(display_name_cells, task_name)});
    load('/core_scripts/data/tc_all_lr_power_808_subs.mat', task_mat_name);
    data_all = eval(task_mat_name); % tp . ROI . no_sub
    os_cat=[];
    for sub=1:100
        clear spectra;
        data=squeeze(data_all(1:176, ROIs_top(task_idx,1:42) ,sub));%* data = time x components
       spectra = amri_sig_fractal(data, Fs);
        if sub==1
            constan=max(spectra.freq)
            freqL=length(spectra.freq)
        end
        if (length(spectra.freq)~=freqL || max(spectra.freq)~=constan)
           fprintf('%d ',sub);
        end
         os=spectra.osci;
        os_cat=cat(3,os_cat,os);
    end
    osci_mean_template(task_idx,:,:) = mean(os_cat,3);
    freqs(task_idx,:)= spectra.freq;
    toc;
end

% %% classify

take_ROIs = 42;
%% classify
confusion_mat=zeros(8,8);
for i = 2:8 % i is actual task
    tic;
    task_name_actual = task_names_run{i}
    task_mat_name = sprintf('tc_%s_concat', task_names_cells{strcmp(display_name_cells, task_name_actual)});
    
    load(all_mat_name,task_mat_name);
    
    data_all = eval(task_mat_name);
    for sub = 1:900
       if mod(sub,50)==0
           fprintf('%d,',sub);
       end
           
        for match_with=2:8
            y=squeeze(data_all(1:176, ROIs_top(match_with,1:take_ROIs),sub));%* data = time x components
            spectra = amri_sig_fractal(y, Fs);
            
            x=squeeze(osci_mean_template(match_with,:,:));
        
            [r,~] = corr(x,spectra.osci);
            result(sub,match_with)=mean(diag(r));
        end
    end
         clear id;
         [~,id(:)]=max(result');
    for match_with=2:8
        confusion_mat(i,match_with)=confusion_mat(i,match_with)+ length(find(id==match_with));
    end   

toc;
end      
  
save('data/osci_ROI_42_classify.mat','confusion_mat');

%% signrank
load('data/osci_ROI_42_classify.mat');
ROI_accuracies=diag(confusion_mat(2:8,2:8));

load('data/Accuracies_all_iter_gpfa');
GPFA_accuracies=diag(squeeze(confusion_mat_os(1,2:8,2:8)));


[p,h] = signrank(GPFA_accuracies./900, ROI_accuracies./900) %p =  0.5781; h=1;

display_name_cells={'rest',   'WM',    'lang',  'motor', 'social', 'gambling', 'relational', 'emotion'}; %human name for the task variables

%% plot as bars
close all;
tasks  = {'W','L','M','S','G','R','E'};

colors = [1,0,0;0,1,0;0,0,0.172413793103448;1,0.103448275862069,0.724137931034483;1,0.827586206896552,0;0,0.344827586206897,0;0.517241379310345,0.517241379310345,1];

for i=1:7
   plot([1 2],[GPFA_accuracies(i)/900  ROI_accuracies(i)/900],'--o','MarkerEdgeColor',colors(i,:),'Color',colors(i,:)) ;hold on;
end

title('compare with accuracies of top 42 ROI oscil');
legend(tasks,'Location','NorthEastOutside');
hold on;
bar([mean(GPFA_accuracies./900)  mean(ROI_accuracies./900)],'FaceColor','None','BarWidth',0.2);
ylim([0.25 1]); set(gca,'XTick',[1 2],'XTickLabel',{'gpfa','ROI'});
