%% compare pca series and gpfa series accuracies
% PCA classification without rest label
clear;
close all;
%%%%%%%%%%%%%% changeable params %%%%%%%%%%%%%%%%%%%%
task_names_run  = {'rest',   'WM',    'lang',  'motor', 'social', 'gambling', 'relational', 'emotion'};
display_name_cells={'rest',   'WM',    'lang',  'motor', 'social', 'gambling', 'relational', 'emotion'}; %human name for the task variables
task_names_cells = {'rest1','task7', 'task2', 'task4', 'task6',  'task3',    'task5',      'task1'}; %matrix names

load('Fig1/data/template_data_power_templates_PCA.mat');

for set_size = [1]
    confusion_mat = zeros(8, 8);
    for tsk_idx = 2:8
        task_name = task_names_run{tsk_idx}
        task_traj_mat_name = sprintf('/core_scripts/data/Sha_pairedProjections_power_pca/Sha_trajs_using_all_%s_PCA.mat', task_name);
        
        load(task_traj_mat_name, 'trajs_all');
        disp(task_name);
        for sub_start = 1:set_size:(901-set_size)
            sub_end = sub_start + set_size-1;
            
            max_correlation = -inf;
            
            matched_task = 0;
            
            for i = 2:length(template_data)
                
                
                
                trajs_curr = [];
                c = 0;
                for sub = sub_start:sub_end
                    c = c+1;
                    trajs_curr(c).xsm = trajs_all(i).trajs(sub).xsm';
                    
                end
                
                
                template_mean_trajectories = template_data(i).mean_trajectories_PCA;
               
                mean_correlation = find_mean_correlation(template_mean_trajectories, trajs_curr);
                
                if mean_correlation > max_correlation
                    max_correlation = mean_correlation;
                    matched_task = i;
                end
            end
            %         fprintf('winner : %s\n', task_names_run{matched_task})
            confusion_mat(tsk_idx, matched_task) =  confusion_mat(tsk_idx, matched_task) + 1;
            
        end
    end
    
    save(sprintf('data/Pca_WoutRest_confusion_mat_set_size_%02d.mat', set_size), 'confusion_mat');
end

%% signrank

load(('data/Pca_WoutRest_confusion_mat_set_size_01.mat'), 'confusion_mat');

pca_cm= diag(confusion_mat(2:8,2:8)./900);
load('data/GPFA42_confusion_mat_without_rest_label.mat');

gp_cm= diag(confusion_mat(2:8,2:8)./900);
[p,h]=signrank(pca_cm,gp_cm) % p=0.6562 h=0
colors = [1,0,0;0,1,0;0,0,0.172413793103448;1,0.103448275862069,0.724137931034483;1,0.827586206896552,0;0,0.344827586206897,0;0.517241379310345,0.517241379310345,1];

figure();
for t=1:7
    i=t;
plot([1 2],[gp_cm(t) pca_cm(t)],'--o','MarkerEdgeColor',colors(i,:),'Color',colors(i,:)) ;hold on;
end
legend (task_names_run(2:8),'Location','NorthEastOutside');
bar([mean(gp_cm),mean(pca_cm)],'FaceColor','None'); hold on;

ylim([0.94 1]); xlabel ('gpfa series | PCA series');

%% compare pca series and gpfa oscil. spectra accuracies
gp=load('Accuracies_all_iter_gpfa'); %created in X2_2_*.m
pcaa=load('Accuracies_all_iter_PCA'); %created in X2_2_*.m

gp_spec=diag(squeeze(gp.confusion_mat_os(1,2:8,2:8)))./900;
pca_spec=diag(squeeze(pcaa.confusion_mat_os(1,2:8,2:8)))./900;

[p,h] = signrank(gp_spec, pca_spec) % p =  0.0156; h=1;

colors = [1,0,0;0,1,0;0,0,0.172413793103448;1,0.103448275862069,0.724137931034483;1,0.827586206896552,0;0,0.344827586206897,0;0.517241379310345,0.517241379310345,1];

for i=1:7
   plot([1 2],[gp_spec(i)  pca_spec(i)],'--o','MarkerEdgeColor',colors(i,:),'Color',colors(i,:)) ;hold on;
end

legend(tasks,'Location','NorthEastOutside');
hold on;
bar([mean(gp_spec)  mean(pca_spec)],'FaceColor','None','BarWidth',0.2);
ylim([0.1 0.9]); set(gca,'XTick',[1 2],'XTickLabel',{'gpfa spec','pca spec'});