addpath(genpath('gpfa_v0203'));
addpath(genpath('chronux_2_12'));
%%
clc;
clear;
close all;
%%%%%%%%%%%%%% changeable params %%%%%%%%%%%%%%%%%%%%
task_names_run  = {'rest',   'WM',    'lang',  'motor', 'social', 'gambling', 'relational', 'emotion'};
display_name_cells={'rest',   'WM',    'lang',  'motor', 'social', 'gambling', 'relational', 'emotion'}; %human name for the task variables
task_names_cells = {'resting','task7', 'task2', 'task4', 'task6',  'task3',    'task5',      'task1'}; %matrix names

load('Fig1/data/template_data_power_templates.mat');

correlation_data_all = [];

set_size = 1;
confusion_mat = zeros(7, 7);
for tsk_idx = 2:8
    correlation_data = [];
    task_name = task_names_run{tsk_idx}
    task_traj_mat_name = sprintf('/core_scripts/data/Sha_pairedProjections_power/Sha_trajs_using_all_%s.mat', task_name);
    
    load(task_traj_mat_name, 'trajs_all');
    
    for sub_start = 1:set_size:(901-set_size)
        sub_end = sub_start + set_size-1;
       
        trajs_curr = [];
        c = 0;
        for sub = sub_start:sub_end
            c = c+1;
            trajs_curr(c).xsm = trajs_all(tsk_idx).trajs(sub).xsm;
            
        end
        
        template_mean_trajectories = template_data(tsk_idx).mean_trajectories;
        template_params = template_data(tsk_idx).estParams;
        
        [~ ,correlation_all] = find_mean_correlation(template_mean_trajectories, template_params, trajs_curr);
        
        correlation_data = [correlation_data ; correlation_all];
   
    end
    correlation_data_all(tsk_idx-1).correlation_data = correlation_data;
    correlation_data_all(tsk_idx-1).task_name = task_name;
    
end

save('data/Sha_correlation_data_without_rest_set_size_01_all_subs.mat', 'correlation_data_all');
