%% Partial correlation on latent trajs
% step 1. find template partial correlation matrices for all tasks
% step 2. for each unknown subject scan, take  latent trajs projected on
% test-task, calculate PC, match with test-task template

addpath(genpath('../../../addons/gpfa_v0203'));
addpath(genpath('../../../addons/chronux_2_12'));

clear; close all;
task_names_run  = {'rest',   'WM',    'lang',  'motor', 'social', 'gambling', 'relational', 'emotion'};
tp=1:176;
for minimize=1
%% step 1

for t=1:8
    disp(task_names_run{t});
%gpfa     
    load(strcat('/core_scripts/data/Sha_pairedProjections/Sha_extracted_trajs_',task_names_run{t},'_entire_templates.mat'));
    bla=[];
    for sub=1:100
        bla=cat(3,bla,trajs(sub).xsm(:,tp)');
    end  
    PC_Tsubs_gpfa(t).task = task_names_run{t};
    PC_Tsubs_gpfa(t).PC = getAllPcFeatures(bla);
end


for t=1:8
PC_template_gpfa(t,:)= mean(PC_Tsubs_gpfa(t).PC');
end

end

%% step 2 get PC for 900 subs
confusion_mat=zeros(8,8);
for t=1:8 %actual task
    disp(task_names_run{t});
%gpfa     
    PC_900subs_gpfa(t).actual_task = task_names_run{t};
    load(strcat('/core_scripts/data/Sha_pairedProjections/Sha_entiretrajs_using_all_',task_names_run{t},'.mat'));
    clear match;
    for tt=1:8 %test task
        bla=[];
        for sub=1:900
            bla=cat(3,bla,trajs_all(tt).trajs(sub).xsm(:,tp)');
        end  
        
        PC_900subs_gpfa(t).tested(tt).test_task= task_names_run{tt};
        PC_900subs_gpfa(t).tested(tt).PC = getAllPcFeatures(bla);
       
        x = PC_template_gpfa(t,:)';
        
        for s=1:900
            y = PC_900subs_gpfa(t).tested(tt).PC(:,s);
            match(s,tt)=corr(x,y);
        end
        
    end
    
    [~,match_win]= max(match');
    
    for tt_i=1:8
    confusion_mat(t,tt_i)=sum(match_win==tt_i);
    end
    
end

save('PC_900subsGPFA.mat','PC_900subs_gpfa','confusion_mat','-v7.3');








