%%  scatter for Motor strength, Language PicVocab, Wm - fluid int correct response, Relational -VSPLOT-off
clear;
metrics=...
{'MMSE-Score', 'PSQI-Score', 'Endurance-AgeAdj', 'Strength-AgeAdj', 'GaitSpeed-Comp', ...
'Dexterity-AgeAdj', 'PicSeq-AgeAdj', 'CardSort-AgeAdj', 'Flanker-AgeAdj', 'PMAT24-A-CR', 'ReadEng-AgeAdj', ...
'PicVocab-AgeAdj', 'ProcSpeed-AgeAdj', 'DDisc-AUC-200', 'DDisc-AUC-40K', 'VSPLOT-TC', 'VSPLOT-OFF', 'SCPT-SEN', ...
'SCPT-SPEC', 'IWRD-TOT','ListSort-AgeAdj', 'PMAT24-A-SI', 'PMAT24-A-RTCR', 'VSPLOT-CRTE', 'SCPT-TPRT', ...
'SCPT-LRNR', 'IWRD-RTC', 'ER40-CR', 'ER40ANG', 'ER40FEAR', 'ER40HAP', 'ER40NOE', 'ER40SAD', 'LifeSatisf-Unadj',...
'MeanPurp-Unadj', 'PosAffect-Unadj', 'Friendship-Unadj', 'EmotSupp-Unadj', 'InstruSupp-Unadj', 'SelfEff-Unadj', ...
'ER40-CRT', 'AngAffect-Unadj', 'AngHostil-Unadj', 'AngAggr-Unadj', 'FearAffect-Unadj', 'FearSomat-Unadj', ...
'Sadness-Unadj', 'Loneliness-Unadj', 'PercHostil-Unadj', 'PercReject-Unadj', 'PercStress-Unadj'};
for l=1:27
   if l==1
       clc;
   end
   fprintf('%d:%s\n',l,metrics{l}) ;
end

behavior_scores=[1 2];
motor_scores=[3 4 5 6 ];
cognition_scores=[7 8 9 13 14 15 ];
fluid_intel_scores =[10 22 23]; 
lang_scores=[11 12];
Spatial_Orientation=[16 17 24];
sustained_attn=[18 19 25 26];
memory =[21 20 27];

all_scores =[behavior_scores lang_scores motor_scores cognition_scores fluid_intel_scores Spatial_Orientation ...
    sustained_attn memory];

 %% Motor strength, Language PicVocab
clear;close all;
against={'y_pred_pos','y_pred_neg','y_pred_both','y_pred_pos_svm','y_pred_neg_svm','y_pred_both_svm'};

 load('data/WS_Sha_PC_toPred_score.mat','Result');
task={'W','L','M','S','G','R','E'};

a=3;

ctr=0;figure;
% GPFA - Sums of +,- PC to pred. behav. X:true | Y:pred | title: task.score
 tsk=2; scr=12; %L12
                eval(strcat('vals=Result(tsk).Res(scr).', against{a},';'));
%                 fprintf('%.1f,%.1f,%.1f,%.1f\n',min(vals),median(vals),mean(vals),max(vals));
                trues=Result(tsk).Res(scr).y_true;
                ctr=ctr+1; subplot(1,2,1);
                trues=zscore(trues);vals=zscore(vals);[r,p]=corr(trues,vals)
                plot(trues,vals,'.');axis square; hold on;
                ax = gca; ax.FontSize = 8;
                ti = title(sprintf('r: %.2f , p: %.3f , %s.%s',r,p,task{tsk},metrics{scr}));
                ti.FontSize = 8;
                plot ( [min([trues;vals]) max([trues;vals])] ,[min([trues;vals]) max([trues;vals])] , '--k');
                xlim([min([trues;vals]) max([trues;vals])]);ylim([min([trues;vals]) max([trues;vals])]);
%                 set(gca,'xcolor','w','ycolor','w');
                set(gca,'box','off');
                
tsk=3; scr=4; %M4
                eval(strcat('vals=Result(tsk).Res(scr).', against{a},';'));
%                 fprintf('%.1f,%.1f,%.1f,%.1f\n',min(vals),median(vals),mean(vals),max(vals));
                trues=Result(tsk).Res(scr).y_true;
                ctr=ctr+1; subplot(1,2,2);
                 trues=zscore(trues);vals=zscore(vals);[r,p]=corr(trues,vals)
                plot(trues,vals,'.');axis square; hold on;
                ax = gca; ax.FontSize = 8;
                ti = title(sprintf('r: %.2f , p: %.3f , %s.%s',r,p,task{tsk},metrics{scr}));
                ti.FontSize = 8;
                plot ( [min([trues;vals]) max([trues;vals])] ,[min([trues;vals]) max([trues;vals])] , '--k');
                xlim([min([trues;vals]) max([trues;vals])]);ylim([min([trues;vals]) max([trues;vals])]);
%                 set(gca,'xcolor','w','ycolor','w');
                set(gca,'box','off');

 %% Wm - fluid int correct response, Relational -VSPLOT-off

clear;close all;
against={'y_pred_pos','y_pred_neg','y_pred_both','y_pred_pos_svm','y_pred_neg_svm','y_pred_both_svm'};

 load('data/WS_Sha_PC_toPred_score.mat','Result');
task={'W','L','M','S','G','R','E'};

a=3;
ctr=0;figure;
% GPFA - Sums of +,- PC to pred. behav. X:true | Y:pred | title: task.score
 tsk=1; scr=10; %W10
                eval(strcat('vals=Result(tsk).Res(scr).', against{a},';'));
%                 fprintf('%.1f,%.1f,%.1f,%.1f\n',min(vals),median(vals),mean(vals),max(vals));
                trues=Result(tsk).Res(scr).y_true;
                ctr=ctr+1; subplot(1,2,1);
                trues=zscore(trues);vals=zscore(vals);[r,p]=corr(trues,vals)
                plot(trues,vals,'.');axis square; hold on;
                ax = gca; ax.FontSize = 8;
                ti = title(sprintf('r: %.2f , p: %.3f , %s.%s',r,p,task{tsk},metrics{scr}));
                ti.FontSize = 8;
                plot ( [min([trues;vals]) max([trues;vals])] ,[min([trues;vals]) max([trues;vals])] , '--k');
                xlim([min([trues;vals]) max([trues;vals])]);ylim([min([trues;vals]) max([trues;vals])]);
%                 set(gca,'xcolor','w','ycolor','w');
                set(gca,'box','off'); set(gca,'xtick',get(gca,'ytick'));
                
tsk=6; scr=16; %R16
                eval(strcat('vals=Result(tsk).Res(scr).', against{a},';'));
%                 fprintf('%.1f,%.1f,%.1f,%.1f\n',min(vals),median(vals),mean(vals),max(vals));
                trues=Result(tsk).Res(scr).y_true;
                ctr=ctr+1; subplot(1,2,2);
                 trues=zscore(trues);vals=zscore(vals);[r,p]=corr(trues,vals)
                plot(trues,vals,'.');axis square; hold on;
                ax = gca; ax.FontSize = 8;
                ti = title(sprintf('r: %.2f , p: %.3f , %s.%s',r,p,task{tsk},metrics{scr}));
                ti.FontSize = 8;
                plot ( [min([trues;vals]) max([trues;vals])] ,[min([trues;vals]) max([trues;vals])] , '--k');
                xlim([min([trues;vals]) max([trues;vals])]);ylim([min([trues;vals]) max([trues;vals])]);
%                 set(gca,'xcolor','w','ycolor','w');
                set(gca,'box','off');set(gca,'xtick',get(gca,'ytick'));

