function [ PC_features ] = getAllPcFeatures( tc_all )
%% function that computes PC features for timeseries in the foll format

[number_tpts,number_regions,number_subjects] = size(tc_all);

PC_features    = zeros(number_regions*(number_regions-1)/2,number_subjects);

for subj = 1:number_subjects

        tc = squeeze(tc_all(:,:,subj)); % n_tpts * n_regions

        % compute the partial correlation as the inverse of the covariance matrix
        Kc = ones(number_regions, number_regions);   
        icX = inv(cov(tc));
        
        for ii = 1:number_regions, 
            for jj = ii+1:number_regions,
                
                Kc(ii,jj) = -icX(ii,jj)/sqrt(icX(ii,ii)*icX(jj,jj));
                Kc(jj,ii) = Kc(ii,jj);
            end
        end
        
        PC_features(:, subj) = Kc(triu(1-eye(number_regions)) == 1);

end
