clearvars
clc;clear all;close all;

% input_data_mcic =load MCIc_comb.mat; 1x22 structure, with spectrum, PC
% and LC(labelled AR) features for each subject

% input_data_mcis =load MCIs_comb.mat; 1x72 structure, with spectrum, PC
% and LC(labelled AR) features for each subject

%%Choose feature set

%SPECTRUM features

% length of spectrum vectorized
feature_length = 32*77;

% reconstruct features
mcic_spectrum = zeros(23,feature_length);
mcis_spectrum = zeros(72,feature_length);

for sindex=1:23
    mcic_spectrum(sindex,:) = (input_data_mcic.allSubjData(sindex).spectrum(:))';
end
mcic_spectrum(9,:)=[];%%REMOVE ERRONEOUS SUBJECT
for sindex=1:72
    mcis_spectrum(sindex,:) = (input_data_mcis.allSubjData(sindex).spectrum(:))';
end
%END SPECTRUM

% 
% % PC Features
% %length of spectrum vectorized
% feature_length = 2926*1;
% 
% % reconstruct features
% mcic_spectrum = zeros(23,feature_length);
% mcis_spectrum = zeros(72,feature_length);
% 
% for sindex=1:23
%     mcic_spectrum(sindex,:) = (input_data_mcic.allSubjData(sindex).PC(:))';
% end
% mcic_spectrum(9,:)=[];%%REMOVE ERRONEOUS SUBJECT
% for sindex=1:72
%     mcis_spectrum(sindex,:) = (input_data_mcis.allSubjData(sindex).PC(:))';
% end
% % END PC Features
%
% LCFeatures
% 
% %length of spectrum vectorized
% feature_length = 77*77;
% 
% % % reconstruct features
% mcic_spectrum = zeros(23,feature_length);
% mcis_spectrum = zeros(72,feature_length);
% 
% for sindex=1:23
%     mcic_spectrum(sindex,:) = (input_data_mcic.allSubjData(sindex).AR(:))';
% end
% mcic_spectrum(9,:)=[];%%REMOVE ERRONEOUS SUBJECT
% for sindex=1:72
%     mcis_spectrum(sindex,:) = (input_data_mcis.allSubjData(sindex).AR(:))';
% end
% END LC features

% %LC + PC
% %length of spectrum vectorized
% feature_length = 8855*1;
%
% %reconstruct features
% mcic_spectrum = zeros(23,feature_length);
% mcis_spectrum = zeros(72,feature_length);
%
% for sindex=1:23
%     mcic_spectrum(sindex,:) = [input_data_mcic.allSubjData(sindex).AR(:); input_data_mcic.allSubjData(sindex).PC(:)]';
% end
% mcic_spectrum(9,:)=[];%%REMOVE ERRONEOUS SUBJECT
% for sindex=1:72
%     mcis_spectrum(sindex,:) = [input_data_mcis.allSubjData(sindex).AR(:) ;input_data_mcis.allSubjData(sindex).PC(:)]';
% end

%%END LC+PC
%-------------------------------------------------------------------------------------



for s1=1:2
    acc_sum_repeat = 0
    acc_plot=[];
        
    %SHUFFLING (OPT.)
    %     shuffle_vector = randperm(42);%CHANGE
    %     joint_data = [rest_training_set_labelss;task_training_set_labelsc];
    %     joint_data = joint_data(shuffle_vector);
    %     rest_training_set_labelss = joint_data(1:21);%%CHANGE
    %     task_training_set_labelsc = joint_data(22:42);%%CHANGE
    %END SHUFFLE
    
    
    acc_sum = 0;
    mcis_spectrum1=mcis_spectrum;
    mcis_spectrum2=mcis_spectrum;
    for s=1:4
        if s==1
            [mcis_spectrum_samples,idx] = datasample(mcis_spectrum1,22,'Replace',false);%%CHANGE
            mcis_spectrum_last16(1:22,:)= mcis_spectrum1(idx,:); %keep the 22 chosen ids for first set to pick 16 elements from in the last set
            mcis_spectrum1(idx,:)=[];
            
        elseif s~=4 && s~=1
            [mcis_spectrum_samples,idx] = datasample(mcis_spectrum1,22,'Replace',false);%%CHANGE
            mcis_spectrum1(idx,:)=[];
            
        else
            [mcis_spectrum_samples,idx] = datasample(mcis_spectrum1,6,'Replace',false);
            [mcis_spectrum_samples2,idx1] = datasample(mcis_spectrum_last16,16,'Replace',false);
            
            mcis_spectrum_samples=[mcis_spectrum_samples;mcis_spectrum_samples2];
            
        end
        
        for i11=1:22
            allSubjData(i11).subID=i11;
            allSubjData(i11).spectrum=mcic_spectrum(i11,:)';
        end
        save('MCIc_LOO.mat','allSubjData');
        clear allSubjData;
        
        for i11=1:22
            allSubjData(i11).subID=i11;
            allSubjData(i11).spectrum=mcis_spectrum_samples(i11,:)';
        end
        save('MCIs_LOO.mat','allSubjData');
        clear allSubjData;
        
        
        %%RFE
              
        %baseDir = add base directory
        
        types={'MCIc_LOO'};
        N1s_auc = 11;%CHANGE
        N1s_acc=11;
        minMax={'max'};
        allFeatures = {{'spectrum'}};
        for runIndex = s
            e=s1.*4-(4-s);
            fprintf('---------------Big RUN -- %d-------------\n',e);
            for featuresNowInd = 1:length(allFeatures)
                featuresNow = allFeatures{featuresNowInd};
                if(size(featuresNow,2)==1)
                    fprintf('---------------Feature RUN - %s-------------\n',string(featuresNow));
                else
                    fprintf('---------------Feature RUN - PC+AR-------------\n');
                end
                in_data_location_sub = baseDir;
                if(size(featuresNow,2)==1)
                    
                    sub_out_data_location_sub = sprintf('%s/RFE/%s/run%d/',baseDir,string(featuresNow),e);
                    out_data_location_sub = sprintf('%s/Results/%s/run%d/',baseDir,string(featuresNow),e);
                    
                    
                else
                    sub_out_data_location_sub = sprintf('%s/RFE/AR+PC/run%d/',baseDir,e);
                    out_data_location_sub = sprintf('%s/Results/AR+PC/run%d/',baseDir,e);
                end
                mkdir(sub_out_data_location_sub);
                mkdir(out_data_location_sub);
                runcombinationsGpfaf2(types, N1s_auc, N1s_acc, minMax, in_data_location_sub, sub_out_data_location_sub, out_data_location_sub, featuresNow);
            end
            clear e;
        end
        
        %%
        delete('MCIc_LOO.mat');
        delete('MCIs_LOO.mat');
        clear idx;
        clear idx1;
        clear mci_spectrum_samples;
    end
end


