clc;
clear;
close all;

mainFig = figure('visible','on'); set(gcf, 'renderer','painters', 'graphicssmoothing', 'on');
load('spectra_meanc.mat','spectra_meanc');%1x77 structure with two fields for each latent dimension, osci= 32x1 matrix for mean PSD across 22 MCIc subjects,freq=32x1 matrix of the frequencies sampled at 
load('spectra_means.mat','spectra_means');%1x77 structure with two fields for each latent dimension, osci= 32x1 matrix for mean PSD across 72 MCIs subjects,freq=32x1 matrix of the frequencies sampled at 
p=0;
sc=[1:-(0.5/77):0.5];

total=[]
for i=1:77
    x=spectra_meanc(i).freq;
    total=[total spectra_meanc(i).osci(:,1)];
    semilogx(x,spectra_meanc(i).osci(:,1),'Color',[1 0 0].*sc(i));                                                  
    hold on;
    
    title('MCIc Spectra');
    xlim([0.0022 0.08]);
    xlabel('frequency (Hz)');
end
frequ = spectra_meanc(1).freq;

semilogx(frequ,mean(total,2),'Color','k');
print(gcf,'-depsc','-painters','gpfa_spectrum_osci_MCIc.eps')
saveas(gcf,'gpfa_spectrum_osci_MCIc.fig');
saveas(gcf,'gpfa_spectrum_osci_MCIc.png');
figure();
total=[];
for i=1:77
    x=spectra_means(i).freq;
    
    total=[total spectra_means(i).osci(:,1)];
    semilogx(x,spectra_means(i).osci(:,1),'Color',[0 0.5 1].*sc(i));
    hold on;
    
    title('MCIs Spectra');
    xlim([0.0022 0.08]); ylim([-0.02 0.12]);
    xlabel('frequency (Hz)');
end
semilogx(frequ,mean(total,2),'Color','k');
print(gcf,'-depsc','-painters','gpfa_spectrum_osci_MCIs.eps')
saveas(gcf,'gpfa_spectrum_osci_MCIs.fig');
saveas(gcf,'gpfa_spectrum_osci_MCIs.png');