feature_mat = load('feature_mat_spectrum.mat');% For CDR_SOB prediction using Spectrum features : 95 subjects x 2464 spectral features
%feature_mat = load('feature_mat_LC_PC.mat'); % For CDR_SOB prediction using LC+PC features : 95 subjects x 8855 spectral features
feature_mat = feature_mat.feature_mat;
feature_mat = [feature_mat(1:8,:); feature_mat(10:31,:); feature_mat(33:66,:); feature_mat(68:95,:)];%Eliminate 2 subjects without CDR scores (32nd and 67th), 1 with erroneous time course (9th)
ft_mat = feature_mat';
load('CDR.mat')
CDR = cell2mat(CDR); %CDR scores of 95 subjects, empty cell if no CDR score available
CDR = [CDR(1:8,:);CDR(10:31,:); CDR(33:66,:); CDR(68:95,:)]; %Eliminate 2 subjects without CDR scores, 1 with erroneous time course 

shuffle=randperm(92);
shuffle=reshape(shuffle,92,1);
CDR_fin=CDR;
for i1=1:92
    
    train_indices = [shuffle(1:i1-1,:) ; shuffle(i1+1:92,:)]; %leave one subject out as test
    train_feat = feature_mat(train_indices,:);
    train_CDR = CDR(train_indices,1);
    
    [coeff,FitInfo] = lasso(train_feat,train_CDR,'Alpha',1);%train on remaining 91 subjects
    [min,min_ind] = min(FitInfo.MSE');
    LambdaMinMSE = FitInfo.Lambda(1,min_ind);
    idxLambdaMinMSE=min_ind;
    coef = coeff(:,idxLambdaMinMSE); %lambda corresponding to min mean square error
    coef0 = FitInfo.Intercept(1,min_ind);% coeff corresponding to this lambda value
    
     
    for j1 = shuffle(i1,:)
        sum=0;
        for k1 = 1:2464 %for spectrum features
        %for k1 = 1:8855 %ar+pc %for LC+PC features
            sum = sum + coef(k1,1).*ft_mat(k1,j1);
        end
        
        CDR(j1,2) = sum + coef0;
    end
    
    clear min;
    clear min_index;
    clear coeff;
    clear FitInfo;
    
end

figure();
scatter(CDR(:,1),CDR(:,2));
[rho,pval]=corr(CDR(:,1),CDR(:,2));
xlabel('Actual CDR scores');
ylabel('Predicted CDR scores');
ax=gca;
l2=lsline(ax);
title(strcat('Spectrum Leave one out lasso Alpha= 1 rho = ',num2str(rho),' pval = ', num2str(pval)));% For Spectrum
title(strcat('Spectrum Leave one out lasso Alpha= 1 rho = ',num2str(rho),' pval = ', num2str(pval)));% For LC+PC