%Add location to gpfa_v0203 toolbox
%%
clear;

%%%%%%%%%%%%%% changeable params %%%%%%%%%%%%%%%%%%%%
binWidth = 1;
startTau = 10;
kernSD = 30;
segLength = 20;
emMaxIters = 100000;
xDim = 77;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

folder = sprintf('GpfaFinal');

if ~isdir(folder)
        mkdir(folder);
end

       
data_all =  load('MCI.mat');
data_all=data_all.MCI;
[T, no_regions, no_subs] = size(data_all);

c = 0;
for sub = 1:95
    c = c+1;
    fprintf('%d ', sub);
    lim = min(size(data_all,1)-10, 100);
    current = data_all(11:lim+10,:,sub);
    current = zscore(current);
    seqTrain(c).trialId = num2str(sub);
    seqTrain(c).y = current';
    seqTrain(c).T = size(current,1);
end
fprintf('\n');
fname = sprintf('%s/gpfa_power_xDim_%02d.mat', folder, xDim);

extraOpts = {'segLength'    segLength    'kernSDList'    kernSD    'emMaxIters'    emMaxIters    'startTau'    startTau};

gpfaEngine(seqTrain, [], fname, 'xDim', xDim, 'binWidth', binWidth, extraOpts{:});
    

