% to calculate total error at different xDims from the cross-validated output data

% add location to gpfa_v0203 toolbox;
%basedir= 'base directory location'
%%
clear;



xDim_all = [5 10 15 20 25 30 35 40 45 50 55 60 65 70 75 80 85 90 95];
num_folds = 3;

     
    %calculating error without orthogonalisation at diiferent xDims
    err_all_no_orth = [];
    for xdim_T = xDim_all
      err = 0;
      err_denom = 0;
      total_points = 0;
      for k=1:num_folds
        fname = sprintf('%s/MCIsfp_gpfaResults_xDim_%03d_cv_%d.mat',basedir, xdim_T, k);
            
        load(fname);
        fn              = sprintf('ycsOrth%02d', xDim);
        Ycs             = [seqTest.(fn)];
        YtestRaw       = [seqTest.y];
        
        err = err + sum((Ycs(:) - YtestRaw(:)).^2); 
        total_points = total_points + length(Ycs(:));
      end
        err_all_no_orth = [err_all_no_orth err/total_points];
    end
    
    xDims_no_orth = xDim_all;
    
    %calculating error with orthogonalisation at diiferent xDims
    xDims_orth = 5:xDim;
    err_all_orth = zeros(1, length(xDims_orth));
    for k=1:num_folds
        fname = sprintf('%s/MCIsfp_gpfaResults_xDim_%03d_cv_%d.mat',basedir,95, k);
        load(fname);
        c = 0;
        for xdim_T = xDims_orth

            fn              = sprintf('ycsOrth%02d', xdim_T);
            Ycs             = [seqTest.(fn)];
            YtestRaw       = [seqTest.y];
            err = sum((Ycs(:) - YtestRaw(:)).^2); 
            c = c+1;
            err_all_orth(c) = err_all_orth(c) + err;
        end
    end
    err_all_orth = err_all_orth/total_points;
    save(sprintf('%s/error_data_cv_MCIsfp_%03d_normalized_mean.mat', basedir,xdim_T), 'xDims_no_orth', 'err_all_no_orth', 'xDims_orth', 'err_all_orth');

