% To run 4-fold cross validated leave-region-out for Power parcellation
% add location to gpfa_v0203 toolbox

%%
clear;

%%%%%%%%%%%%%% changeable params %%%%%%%%%%%%%%%%%%%%

binWidth = 1;
startTau = 10;
kernSD = 30;
segLength = 15;
emMaxIters = 100000;
%basedir= 'base directory location'
           
load('MCI.mat');   data_all = MCI(:,:,1:93);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

num_folds = 3;
fold_size = 31;

    for xDim = [5 10 15 20 25 30 35 40 45 50 55 60 65 70 75 80 85 90]
      
        for k=1:3
                       
            if k==1
                train_indices_kth=[32:93]
                test_indices_kth=[1:31]
                
            elseif k==2
                train_indices_kth=[1:31 63:93]
                test_indices_kth=[32:62]

            else
                train_indices_kth=[1:62]
                test_indices_kth=[63:93]

                end
                
            
            [T, no_regions, no_subs] = size(data_all);
            disp('train data');
            c = 1;
            for sub = train_indices_kth
                disp(sub);
                lim = min(size(data_all,1)-10, 100);
                current = data_all(11:lim+10,:,sub);
                current = zscore(current);
                seqTrain(c).trialId = num2str(sub);
                seqTrain(c).y = current';
                seqTrain(c).T = size(current,1);
                c = c+1;
            end
            disp('test data');
            c = 1;
            for sub = test_indices_kth
                disp(sub);
                lim = min(size(data_all,1)-10, 100);
                current = data_all(11:lim+10,:,sub);
                current = zscore(current);
                seqTest(c).trialId = num2str(sub);
                seqTest(c).y = current';
                seqTest(c).T = size(current,1);
                c = c+1;
            end
            
         
           
            fname = sprintf('%s/MCIsfp_gpfaResults_xDim_%03d_cv_%d.mat',basedir,xDim, k);
            
            extraOpts = {'segLength'    segLength    'kernSDList'    kernSD    'emMaxIters'    emMaxIters    'startTau'    startTau};
            
            gpfaEngine(seqTrain, seqTest, fname, 'xDim', xDim, 'binWidth', binWidth, extraOpts{:});
        end
    end
