%% normalize_zscore : this function normalizes the feature vector based on z-score normalization
%% the normalization is done across 
function [cohortI_modified,cohortII_modified] = normalize_zscore(cohortI,cohortII,matrix_type)
	if matrix_type == 1
		PCindex = 91;
		ARindex = 287;
	end
	if matrix_type == 2
		CSindex = 68;
		CTindex = 136;
	end
	if matrix_type == 3
		PCindex = 91;
		ARindex = 287;
		CSindex = 355;
		CTindex = 423;
	end

	joinmatrix = [cohortI,cohortII];

	if matrix_type==3
		%%normalize Partial correlation features
		PCArray = reshape(joinmatrix(1:PCindex,:),1,[]);
		PCmean = mean(PCArray);
		PCstd = std(PCArray);
		for i=1:PCindex
			joinmatrix(i,:) = (joinmatrix(i,:)-PCmean)/PCstd;
		end

		%%normalize Autoregression features
		ARArray = reshape(joinmatrix(PCindex+1:ARindex,:),1,[]);
		ARmean = mean(ARArray);
		ARstd = std(ARArray);
		for i=PCindex+1:ARindex
			joinmatrix(i,:) = (joinmatrix(i,:)-ARmean)/ARstd;
		end

		%%normalize Cortical Surface Area
		CSArray = reshape(joinmatrix(ARindex+1:CSindex,:),1,[]);
		CSmean = mean(CSArray);
		CSstd = std(CSArray);
		for i=ARindex+1:CSindex
			joinmatrix(i,:) = (joinmatrix(i,:)-CSmean)/CSstd;
		end

		%%normalize Cortical Thickness 
		CTArray = reshape(joinmatrix(CSindex+1:CTindex,:),1,[]);
		CTmean = mean(CTArray);
		CTstd = std(CTArray);
		for i=CSindex+1:CTindex
			joinmatrix(i,:) = (joinmatrix(i,:)-CTmean)/CTstd;
		end

		cohortI_modified = joinmatrix(:,1:size(cohortI,2));
		cohortII_modified = joinmatrix(:,size(cohortI,2)+1:end);
	end


	if matrix_type==2
		
		%%normalize Cortical Surface Area
		CSArray = reshape(joinmatrix(1:CSindex,:),1,[]);
		CSmean = mean(CSArray);
		CSstd = std(CSArray);
		for i=1:CSindex
			joinmatrix(i,:) = (joinmatrix(i,:)-CSmean)/CSstd;
		end

		%%normalize Cortical Thickness 
		CTArray = reshape(joinmatrix(CSindex+1:CTindex,:),1,[]);
		CTmean = mean(CTArray);
		CTstd = std(CTArray);
		for i=CSindex+1:CTindex
			joinmatrix(i,:) = (joinmatrix(i,:)-CTmean)/CTstd;
		end

		cohortI_modified = joinmatrix(:,1:size(cohortI,2));
		cohortII_modified = joinmatrix(:,size(cohortI,2)+1:end);
	end

	if matrix_type==1
		%%normalize Partial correlation features
		PCArray = reshape(joinmatrix(1:PCindex,:),1,[]);
		PCmean = mean(PCArray);
		PCstd = std(PCArray);
		for i=1:PCindex
			joinmatrix(i,:) = (joinmatrix(i,:)-PCmean)/PCstd;
		end

		%%normalize Autoregression features
		ARArray = reshape(joinmatrix(PCindex+1:ARindex,:),1,[]);
		ARmean = mean(ARArray);
		ARstd = std(ARArray);
		for i=PCindex+1:ARindex
			joinmatrix(i,:) = (joinmatrix(i,:)-ARmean)/ARstd;
		end

		cohortI_modified = joinmatrix(:,1:size(cohortI,2));
		cohortII_modified = joinmatrix(:,size(cohortI,2)+1:end);
	end

	if matrix_type==4 %this is the standard z-score normalization
		joinmatrix = [cohortI,cohortII];
		joinmatrix = zscore(joinmatrix,[],2); %z-score along rows
		cohortI_modified = joinmatrix(:,1:size(cohortI,2));
		cohortII_modified = joinmatrix(:,size(cohortI,2)+1:end);
	end






