addpath(genpath('../../../addons/gpfa_v0203'));
addpath(genpath('../../../addons/chronux_2_12'));

%%

clear;

display_name_cells={'rest',   'WM',    'lang',  'motor', 'social', 'gambling', 'relational', 'emotion'}; %human name for the task variables
task_names_cells = {'rest1','task7', 'task2', 'task4', 'task6',  'task3',    'task5',      'task1'}; %matrix names

task_name = 'WM';
total_points_to_consider = 100;


load('/core_scripts/data/predictOn_subject_IDs.mat');
task_mat_name = sprintf('tc_%s_concat', task_names_cells{strcmp(display_name_cells, task_name)});
load(sprintf('/core_scripts/power_templates_as_trials/gpfa_%s_power_xDim_42.mat', task_name), 'estParams'); 
load('/core_scripts/data/tc_all_LR_power_predictOn900.mat', task_mat_name);

data_all = eval(task_mat_name);

clear task_mat_name;

folder = '/HCP_data/EV_files_final_1000'; % downloaded from HCP database


[total_points, no_regions, no_subs] = size(data_all);

sub_count = 1;
seqTrain = [];
for sub=1:900   
   
    task_structure = zeros(1, total_points);
    sub_id = num2str(predictOn_subject_IDs(sub));
    
    
    curr_points = load(sprintf('%s/%s/LR/%s.txt', folder, sub_id, '0bk_body'));
    for c=1:size(curr_points, 1)
        start_point = round(curr_points(c, 1)*1000/720) + 1;
        end_point = round((curr_points(c, 1) + curr_points(c, 2))*1000/720) + 1;
        task_structure(start_point:end_point) = 1;
    end
    
    curr_points = load(sprintf('%s/%s/LR/%s.txt', folder, sub_id, '0bk_faces'));
    for c=1:size(curr_points, 1)
        start_point = round(curr_points(c, 1)*1000/720) + 1;
        end_point = round((curr_points(c, 1) + curr_points(c, 2))*1000/720) + 1;
        task_structure(start_point:end_point) = 1;
    end
    
    curr_points = load(sprintf('%s/%s/LR/%s.txt', folder, sub_id, '0bk_places'));
    for c=1:size(curr_points, 1)
        start_point = round(curr_points(c, 1)*1000/720) + 1;
        end_point = round((curr_points(c, 1) + curr_points(c, 2))*1000/720) + 1;
        task_structure(start_point:end_point) = 1;
    end
    
    curr_points = load(sprintf('%s/%s/LR/%s.txt', folder, sub_id, '0bk_tools'));
    for c=1:size(curr_points, 1)
        start_point = round(curr_points(c, 1)*1000/720) + 1;
        end_point = round((curr_points(c, 1) + curr_points(c, 2))*1000/720) + 1;
        task_structure(start_point:end_point) = 1;
    end
    
    
    
    task_structure = task_structure(1:total_points);
    eligible_points = find(task_structure==1);
    final_points = eligible_points(1:total_points_to_consider);
    fprintf('%d ', sub);
    current = data_all(final_points,:,sub);
    current = zscore(current);
    seqTrain(sub_count).trialId = num2str(sub);
    seqTrain(sub_count).y = current';
    seqTrain(sub_count).T = size(current,1);
    sub_count = sub_count + 1;
end  
fprintf('\n');


[blah, ~] = exactInferenceWithLL(seqTrain, estParams);
  


trajs_0bk = [];

for c=1:length(blah)   
    trajs_0bk(c).xsm = blah(c).xsm;
    trajs_0bk(c).y = blah(c).y;
    trajs_0bk(c).T = blah(c).T;
    trajs_0bk(c).trialId = blah(c).trialId;
end


sub_count = 1;
seqTrain = [];
for sub=1:900   
   
    task_structure = zeros(1, total_points);
    sub_id = num2str(predictOn_subject_IDs(sub));
    
    
    curr_points = load(sprintf('%s/%s/LR/%s.txt', folder, sub_id, '2bk_body'));
    for c=1:size(curr_points, 1)
        start_point = round(curr_points(c, 1)*1000/720) + 1;
        end_point = round((curr_points(c, 1) + curr_points(c, 2))*1000/720) + 1;
        task_structure(start_point:end_point) = 1;
    end
    
    curr_points = load(sprintf('%s/%s/LR/%s.txt', folder, sub_id, '2bk_faces'));
    for c=1:size(curr_points, 1)
        start_point = round(curr_points(c, 1)*1000/720) + 1;
        end_point = round((curr_points(c, 1) + curr_points(c, 2))*1000/720) + 1;
        task_structure(start_point:end_point) = 1;
    end
    
    curr_points = load(sprintf('%s/%s/LR/%s.txt', folder, sub_id, '2bk_places'));
    for c=1:size(curr_points, 1)
        start_point = round(curr_points(c, 1)*1000/720) + 1;
        end_point = round((curr_points(c, 1) + curr_points(c, 2))*1000/720) + 1;
        task_structure(start_point:end_point) = 1;
    end
    
    curr_points = load(sprintf('%s/%s/LR/%s.txt', folder, sub_id, '2bk_tools'));
    for c=1:size(curr_points, 1)
        start_point = round(curr_points(c, 1)*1000/720) + 1;
        end_point = round((curr_points(c, 1) + curr_points(c, 2))*1000/720) + 1;
        task_structure(start_point:end_point) = 1;
    end
    
    
    
    task_structure = task_structure(1:total_points);
    eligible_points = find(task_structure==1);
    final_points = eligible_points(1:total_points_to_consider);
    fprintf('%d ', sub);
    current = data_all(final_points,:,sub);
    current = zscore(current);
    seqTrain(sub_count).trialId = num2str(sub);
    seqTrain(sub_count).y = current';
    seqTrain(sub_count).T = size(current,1);
    sub_count = sub_count + 1;
end  
fprintf('\n');


[blah, ll] = exactInferenceWithLL(seqTrain, estParams);
  


trajs_2bk = [];

for c=1:length(blah)   
    trajs_2bk(c).xsm = blah(c).xsm;
    trajs_2bk(c).y = blah(c).y;
    trajs_2bk(c).T = blah(c).T;
    trajs_2bk(c).trialId = blah(c).trialId;
end



save('Sha_trajs_test_WM.mat', 'trajs_0bk', 'trajs_2bk');
