addpath(genpath('../../../addons/gpfa_v0203'));
addpath(genpath('../../../addons/chronux_2_12'));

%%

clear;

display_name_cells={'rest',   'WM',    'lang',  'motor', 'social', 'gambling', 'relational', 'emotion'}; %human name for the task variables
task_names_cells = {'resting','task7', 'task2', 'task4', 'task6',  'task3',    'task5',      'task1'}; %matrix names


task_idx = 8;
task_name = display_name_cells{task_idx};
total_points_to_consider = 66;

load('/core_scripts/data/template_subjects_IDs.mat');
task_mat_name = sprintf('tc_%s_concat', task_names_cells{strcmp(display_name_cells, task_name)});
load(sprintf('/core_scripts/power_templates_as_trials/gpfa_%s_power_xDim_42.mat', task_name), 'estParams'); 
load('/core_scripts/data/tc_all_lr_power_808_subs.mat', task_mat_name);

data_all = eval(task_mat_name);

clear task_mat_name;

folder = '/HCP_data/EV_files_final_1000'; % downloaded from HCP database


[total_points, no_regions, no_subs] = size(data_all);

sub_count = 1;
seqTrain = [];
for sub=1:100   
   
    task_structure = zeros(1, total_points);
    sub_id = num2str(template_subjects_IDs(sub));
    
    
    curr_points = load(sprintf('%s/%s/LR/%s.txt', folder, sub_id, 'neut'));
    for c=1:size(curr_points, 1)
        start_point = round(curr_points(c, 1)*1000/720) + 1;
        end_point = round((curr_points(c, 1) + curr_points(c, 2))*1000/720) + 1;
        task_structure(start_point:end_point) = 1;
    end
    
    task_structure = task_structure(1:total_points);
    eligible_points = find(task_structure==1);
    final_points = eligible_points(1:total_points_to_consider);
    fprintf('%d ', sub);
    current = data_all(final_points,:,sub);
    current = zscore(current);
    seqTrain(sub_count).trialId = num2str(sub);
    seqTrain(sub_count).y = current';
    seqTrain(sub_count).T = size(current,1);
    sub_count = sub_count + 1;
end  
fprintf('\n');


[blah, ~] = exactInferenceWithLL(seqTrain, estParams);
  


trajs_neutral = [];

for c=1:length(blah)   
    trajs_neutral(c).xsm = blah(c).xsm;
    trajs_neutral(c).y = blah(c).y;
    trajs_neutral(c).T = blah(c).T;
    trajs_neutral(c).trialId = blah(c).trialId;
end


mean_trajs_neutral = [];

for dim = 1:size(trajs_neutral(1).xsm, 1)    
        xsm_curr_dim = [];
        for sub=1:length(trajs_neutral)
            xsm_curr_dim = [xsm_curr_dim; trajs_neutral(sub).xsm(dim, :)];
        end
        mean_trajs_neutral = [mean_trajs_neutral; mean(xsm_curr_dim)];
end 

template_data(1).mean_trajectories = mean_trajs_neutral;
template_data(1).subtask_name = 'neutral';










sub_count = 1;
seqTrain = [];
for sub=1:100   
   
    task_structure = zeros(1, total_points);
    sub_id = num2str(template_subjects_IDs(sub));
    
    
    
    curr_points = load(sprintf('%s/%s/LR/%s.txt', folder, sub_id, 'fear'));
    for c=1:size(curr_points, 1)
        start_point = round(curr_points(c, 1)*1000/720) + 1;
        end_point = round((curr_points(c, 1) + curr_points(c, 2))*1000/720) + 1;
        task_structure(start_point:end_point) = 1;
    end
    
    
    task_structure = task_structure(1:total_points);
    eligible_points = find(task_structure==1);
    final_points = eligible_points(1:total_points_to_consider);
    fprintf('%d ', sub);
    current = data_all(final_points,:,sub);
    current = zscore(current);
    seqTrain(sub_count).trialId = num2str(sub);
    seqTrain(sub_count).y = current';
    seqTrain(sub_count).T = size(current,1);
    sub_count = sub_count + 1;
end  
fprintf('\n');


[blah, ll] = exactInferenceWithLL(seqTrain, estParams);
  


trajs_fear = [];

for c=1:length(blah)   
    trajs_fear(c).xsm = blah(c).xsm;
    trajs_fear(c).y = blah(c).y;
    trajs_fear(c).T = blah(c).T;
    trajs_fear(c).trialId = blah(c).trialId;
end


mean_trajs_fear = [];

for dim = 1:size(trajs_fear(1).xsm, 1)    
        xsm_curr_dim = [];
        for sub=1:length(trajs_fear)
            xsm_curr_dim = [xsm_curr_dim; trajs_fear(sub).xsm(dim, :)];
        end
        mean_trajs_fear = [mean_trajs_fear; mean(xsm_curr_dim)];
end 

template_data(2).mean_trajectories = mean_trajs_fear;
template_data(2).subtask_name = 'fear';


save(sprintf('trajs_templates_%s.mat', task_name), 'trajs_neutral', 'trajs_fear');

save(sprintf('template_data_%s.mat', task_name), 'template_data');
