addpath(genpath('../../../addons/gpfa_v0203'));
addpath('../../../addons/spm12');
%%

clear;
close all;
%%%%%%%%%%%%%% changeable params %%%%%%%%%%%%%%%%%%%%
task_names_run  = {'WM',    'lang',  'motor', 'social', 'gambling', 'relational', 'emotion'};
task_names_run_fig  = {'Working Memory',    'Language',  'Motor', 'Social', 'Gambling', 'Relational', 'Emotion'};
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
make_it_tight = true;
subplot = @(m,n,p) subtightplot (m, n, p, [0.04 0.04], [0.03 0.06], [0.0 0.0]);

close all;
mainFig = figure('visible','off'); set(gcf,'Position',[10,10, 580*4, 435*7], 'renderer','painters', 'graphicssmoothing', 'on');


c=1;

for tsk_idx = 1:7
    
    task_name = task_names_run{tsk_idx}
    
    ax = subplot(7, 4, c);
    text(0.2,0.5, task_names_run_fig{tsk_idx}, 'FontSize',35,  'Interpreter', 'Latex');
    set ( ax, 'visible', 'off')
    
    c = c + 1;
    
    load(sprintf('Fig1/data/template_data_power_templates.mat'));
    load(sprintf('Fig3/data/Sha_correlation_data_without_rest_set_size_01_all_subs.mat'));
    
    
    axeslimit = 2;
    
    correlation_data = correlation_data_all(tsk_idx).correlation_data;
    
    [~, indices] = sort(sum(correlation_data), 'descend');
    
    comp_no_1 = indices(1);
    
    comp_no_2 = indices(2);
    
    mean_traj_1 = template_data(tsk_idx+1).mean_trajectories(comp_no_1, :);
    
    mean_traj_2 = template_data(tsk_idx+1).mean_trajectories(comp_no_2, :);
    
    
    task_traj_mat_name = sprintf('/core_scripts/data/Sha_pairedProjections_power/Sha_trajs_using_all_%s.mat', task_name);
    load(task_traj_mat_name, 'trajs_all');
    
    dim1 = [];
    dim2 = [];
    points = [];
    axt = subplot(7, 4,c);
    corr_sum = 0;
    num_of_subs = 0;
    for sub = 1:900
        
        dim1 = [dim1; trajs_all(tsk_idx+1).trajs(sub).xsm(comp_no_1, :)];
        dim2 = [dim2; trajs_all(tsk_idx+1).trajs(sub).xsm(comp_no_2, :)];
        points = [points; trajs_all(tsk_idx+1).trajs(sub).xsm(comp_no_1, :)' trajs_all(tsk_idx+1).trajs(sub).xsm(comp_no_2, :)'];
        corr_sum = corr_sum + corr(trajs_all(tsk_idx+1).trajs(sub).xsm(comp_no_1, :)', mean_traj_1')+...
            corr(trajs_all(tsk_idx+1).trajs(sub).xsm(comp_no_2, :)', mean_traj_2');
        num_of_subs = num_of_subs + 1;
    end
    
    pts = linspace(-axeslimit, axeslimit, 101);
    
    N = histcounts2(points(:, 2), points(:, 1), pts, pts);
    [xG, yG] = meshgrid(-5:5);
    sigma = 2.5;
    g = exp(-xG.^2./(2.*sigma.^2)-yG.^2./(2.*sigma.^2));
    g = g./sum(g(:));
    
    imagesc(pts, pts, conv2(N, g, 'same'));
    hold on;
    temp = conv2(N, g, 'same');
             colormap(b2r(0, max(temp(:))));
    
    colorbar;
    
    hold on;
    pl1 = plot(mean_traj_1, mean_traj_2, 'color', 'y', 'linewidth', 2);
    pl1.Color(4) = 0.7;
    hold on;
    pl2 = plot(mean(dim1), mean(dim2), 'color', [0.7 0.7 0.7], 'linewidth', 2);
    pl2.Color(4) = 0.7;
    set(gca,'YDir','normal')
    
    
    set(axt, 'box', 'on', 'Visible', 'on', 'linewidth', 2, 'color', 'g');
    ax = gca;
    %     ax.XColor = 'green';
    %     ax.YColor = 'green';
    
    ylim([-axeslimit axeslimit])
    xlim([-axeslimit axeslimit])
%     xlabel(sprintf('dynamics (component %d)',1) ,  'Interpreter', 'Latex', 'FontSize', 18);
%     ylabel(sprintf('dynamics (component %d)',2) ,  'Interpreter', 'Latex', 'FontSize', 18);
    
    title(sprintf('\\textbf{Correlation : %.3f}', corr_sum/(2*num_of_subs)), 'Interpreter', 'Latex', 'FontSize', 20);
    c = c + 1;
    
    axeslimit = 12;
    load(sprintf('Fig1/data/template_data_power_templates_with_orth.mat'));
    
    
    task_traj_mat_name = sprintf('/core_scripts/data/Sha_pairedProjections/Sha_trajs_using_all_%s_orth.mat', task_name);
    load(task_traj_mat_name, 'trajs_all');
    
    
    mean_traj_1 = template_data(tsk_idx+1).mean_trajectories_orth(1, :);
    mean_traj_2 = template_data(tsk_idx+1).mean_trajectories_orth(2, :);
    
    dim1 = [];
    dim2 = [];
    points = [];
    axt = subplot(7, 4,c);
    corr_sum = 0;
    num_of_subs = 0;
    for sub = 1:900
        
        dim1 = [dim1; trajs_all(tsk_idx+1).trajs(sub).xorth(1, :)];
        dim2 = [dim2; trajs_all(tsk_idx+1).trajs(sub).xorth(2, :)];
        points = [points; trajs_all(tsk_idx+1).trajs(sub).xorth(1, :)' trajs_all(tsk_idx+1).trajs(sub).xorth(2, :)'];
        corr_sum = corr_sum + corr(trajs_all(tsk_idx+1).trajs(sub).xorth(1, :)', mean_traj_1')+...
            corr(trajs_all(tsk_idx+1).trajs(sub).xorth(2, :)', mean_traj_2');
        num_of_subs = num_of_subs + 1;
    end
    
    
    pts = linspace(-axeslimit, axeslimit, 101);
    
    N = histcounts2(points(:, 2), points(:, 1), pts, pts);
    [xG, yG] = meshgrid(-5:5);
    sigma = 2.5;
    g = exp(-xG.^2./(2.*sigma.^2)-yG.^2./(2.*sigma.^2));
    g = g./sum(g(:));
    
    imagesc(pts, pts, conv2(N, g, 'same'));
    hold on;
    temp = conv2(N, g, 'same');
            colormap(b2r(0, max(temp(:))));
    
    colorbar;
    hold on;
    pl1 = plot(mean_traj_1, mean_traj_2, 'color', 'y', 'linewidth', 2);
    pl1.Color(4) = 0.7;
    hold on;
    pl2 = plot(mean(dim1), mean(dim2), 'color', [0.7 0.7 0.7], 'linewidth', 2);
    pl2.Color(4) = 0.7;
    set(gca,'YDir','normal')
    
    set(axt, 'box', 'on', 'Visible', 'on', 'linewidth', 2, 'color', 'g');
    ax = gca;
    
    ylim([-axeslimit axeslimit])
    xlim([-axeslimit axeslimit])
    xlabel(sprintf('dynamics (component %d)',1) ,  'Interpreter', 'Latex', 'FontSize', 18);
    ylabel(sprintf('dynamics (component %d)',2) ,  'Interpreter', 'Latex', 'FontSize', 18);
    title(sprintf('\\textbf{Correlation : %.3f}', corr_sum/(2*num_of_subs)), 'Interpreter', 'Latex', 'FontSize', 20);
    
    c = c + 1;
    
    
    axeslimit = 12;
    
    load(sprintf('Fig1/data/template_data_power_templates_PCA.mat'));
    
    mean_traj_1 = template_data(tsk_idx+1).mean_trajectories_PCA(1, :);
    mean_traj_2 = template_data(tsk_idx+1).mean_trajectories_PCA(2, :);
    
    task_traj_mat_name = sprintf('/core_scripts/data/Sha_pairedProjections/Sha_trajs_using_all_%s_PCA.mat', task_name);
    load(task_traj_mat_name, 'trajs_all');
    
    dim1 = [];
    dim2 = [];
    points = [];
    axt = subplot(7, 4,c);
    corr_sum = 0;
    num_of_subs = 0;
    for sub = 1:900
        xsm = trajs_all(tsk_idx+1).trajs(sub).xsm';
        
        dim1 = [dim1; xsm(1, :)];
        dim2 = [dim2; xsm(2, :)];
        points = [points; xsm(1, :)' xsm(2, :)'];
        corr_sum = corr_sum + corr(xsm(1, :)', mean_traj_1')+...
            corr(xsm(2, :)', mean_traj_2');
        num_of_subs = num_of_subs + 1;
    end
    
    
    
    pts = linspace(-axeslimit, axeslimit, 101);
    
    N = histcounts2(points(:, 2), points(:, 1), pts, pts);
    [xG, yG] = meshgrid(-5:5);
    sigma = 2.5;
    g = exp(-xG.^2./(2.*sigma.^2)-yG.^2./(2.*sigma.^2));
    g = g./sum(g(:));
    
    imagesc(pts, pts, conv2(N, g, 'same'));
    hold on;
    temp = conv2(N, g, 'same');
            colormap(b2r(0, max(temp(:))));
    
    colorbar;
    hold on;
    pl1 = plot(mean_traj_1, mean_traj_2, 'color', 'y', 'linewidth', 2);
    pl1.Color(4) = 0.7;
    hold on;
    pl2 = plot(mean(dim1), mean(dim2), 'color', [0.7 0.7 0.7], 'linewidth', 2);
    pl2.Color(4) = 0.7;
    set(gca,'YDir','normal')
    
    set(axt, 'box', 'on', 'Visible', 'on', 'linewidth', 2, 'color', 'g');
    ax = gca;
    
    ylim([-axeslimit axeslimit])
    xlim([-axeslimit axeslimit])
    xlabel(sprintf('dynamics (component %d)',1) ,  'Interpreter', 'Latex', 'FontSize', 18);
    ylabel(sprintf('dynamics (component %d)',2) ,  'Interpreter', 'Latex', 'FontSize', 18);
    title(sprintf('\\textbf{Correlation : %.3f}', corr_sum/(2*num_of_subs)), 'Interpreter', 'Latex', 'FontSize', 20);
    
    c = c + 1;
    
    
    
end
